package kr.co.icontrols.ilp300_700.admin.test;

import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.util.Log;
import android.view.Gravity;
import android.view.KeyEvent;
import android.widget.RelativeLayout;

import kr.co.icontrols.ilp300_700.MainActivity;
import kr.co.icontrols.ilp300_700.R;
import kr.co.icontrols.ilp300_700.ethernet.PingTest;
import kr.co.icontrols.ilp300_700.global.Configure.ConfigValue;
import kr.co.icontrols.ilp300_700.global.DataClasses.POSITION;
import kr.co.icontrols.ilp300_700.global.Declare;
import kr.co.icontrols.ilp300_700.global.Enumeration.DATAINPUTSCREEN;
import kr.co.icontrols.ilp300_700.global.Global;
import kr.co.icontrols.ilp300_700.global.ID;
import kr.co.icontrols.wallpadsupport.WpadImageView;
import kr.co.icontrols.wallpadsupport.WpadScreen;
import kr.co.icontrols.wallpadsupport.WpadTextView;

public class AdminSet_Test_Network extends WpadScreen {

    String TAG = "AdminSet_Test_Network";

    boolean bLOG = true;   // true, false
    boolean bLOG_DEBUG = false;   // true, false
    boolean bLOG_INFO = false;   // true, false
    Context mContext;
    WpadImageView Image_Background;
    WpadTextView Text_Title;
    WpadTextView Text_Line_01_Item;
    WpadTextView Text_Line_02_Item;
    WpadTextView Text_Line_03_Item;
    WpadTextView Text_Line_04_Item;
    int TextColor_Normal = Color.WHITE;
    int TextColor_Highlight = Color.GREEN;
    int TextColor_Red = Color.RED;
    int nFontSize_Instruction = 28;
    boolean bFontNonBold = false;
    boolean bFontBold = true;
    boolean bFUNCBlock = false;
    String strText_Title = "네트워크";
    String strText_Line_01_Item = "1] 단지서버";
    String strText_Line_02_Item = "2] 관리PC";
    String strText_Line_03_Item = "3] IP 수동입력";
    String strText_Line_04_Item = "* 메뉴를 선택하세요 *";
    public AdminSet_Test_Network(Context context, RelativeLayout layout) {
        super(context, layout);
        try {
            LOG("------------------ [START - AdminSet_Test_Network] -------------------");

            mContext = context;
            Initialize();

            Image_Background = new WpadImageView(context, 0, Declare.DeviceInfo.getScreenSizeFullW(ConfigValue.DEVICE_MODELTYPE), Declare.DeviceInfo.getScreenSizeFullH(ConfigValue.DEVICE_MODELTYPE), R.drawable.bg_back, 0, ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.IMAGES.BACKGROUND);
            ViewRegistration(layout, Image_Background, 0, 0);

            Text_Title = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.TITLE).W, getPosition(ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.TITLE).H, Gravity.CENTER, Color.WHITE, nFontSize_Instruction, bFontBold, ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.TITLE);
            ViewRegistration(layout, Text_Title, getPosition(ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.TITLE).X, getPosition(ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.TITLE).Y);
            Text_Title.setText(strText_Title);

            Text_Line_01_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.LINE_01_Item).W, getPosition(ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.LINE_01_Item).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.LINE_01_Item);
            ViewRegistration(layout, Text_Line_01_Item, getPosition(ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.LINE_01_Item).X, getPosition(ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.LINE_01_Item).Y);
            Text_Line_01_Item.setText(strText_Line_01_Item);

            Text_Line_02_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.LINE_02_Item).W, getPosition(ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.LINE_02_Item).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.LINE_02_Item);
            ViewRegistration(layout, Text_Line_02_Item, getPosition(ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.LINE_02_Item).X, getPosition(ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.LINE_02_Item).Y);
            Text_Line_02_Item.setText(strText_Line_02_Item);

            Text_Line_03_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.LINE_03_Item).W, getPosition(ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.LINE_03_Item).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.LINE_03_Item);
            ViewRegistration(layout, Text_Line_03_Item, getPosition(ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.LINE_03_Item).X, getPosition(ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.LINE_03_Item).Y);
            Text_Line_03_Item.setText(strText_Line_03_Item);

            Text_Line_04_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.LINE_04_Item).W, getPosition(ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.LINE_04_Item).H, Gravity.CENTER, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.LINE_04_Item);
            ViewRegistration(layout, Text_Line_04_Item, getPosition(ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.LINE_04_Item).X, getPosition(ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.LINE_04_Item).Y);
            Text_Line_04_Item.setText(strText_Line_04_Item);

            UpdateScreen();
            ((MainActivity) mContext).setAutoScreenChange(ID.SCREENS.Main, MainActivity.nAdminScreenTimeout);
        } catch (Exception e) {
            Log.e(TAG, "[Exception] AdminSet_Test_Network(...) : " + e);
            e.printStackTrace();
        }
    }

    private void LOG(String log) {
        if (bLOG) Log.v(TAG, log);
    }

    private void LOG_DEBUG(String log) {
        if (bLOG_DEBUG) Log.d(TAG, log);
    }

    private void LOG_INFO(String log) {
        if (bLOG_INFO) Log.i(TAG, log);
    }

    protected void Initialize() {
        try {
            LOG("[Initialize] Start!!");
            Global.DataInputScreen = DATAINPUTSCREEN.DETAIL_01;
        } catch (Exception e) {
            Log.e(TAG, "[Exception] Initialize() : " + e);
            e.printStackTrace();
        }
    }

    @Override
    protected void onClose() {
        try {
            LOG("------------------ [onClose - AdminSet_Test_Network] -------------------");
        } catch (Exception e) {
            Log.e(TAG, "[Exception] onClose() : " + e);
            e.printStackTrace();
        }
        super.onClose();
    }

    @Override
    protected void onBrReceive(Intent intent) {
        try {
            LOG("[onBrReceive] Intent : " + intent);
        } catch (Exception e) {
            Log.e(TAG, "[Exception] onBrReceive(...) : " + e);
            e.printStackTrace();
        }
        super.onBrReceive(intent);
    }

    @Override
    protected void onKeyDown(int keyCode, KeyEvent event) {
        try {
//            LOG("[onKeyDown] keyCode [" + keyCode + "], event [" + event + "]");
            if (keyCode == Declare.Button.NUMBER_01) {
                // 단지서버
                if (!checkNetworkStatus(ConfigValue.strMainServerIPAddress)) {
                    MainActivity.mSound.PlayMent_lobby(R.raw.retryinput);
                }
            } else if (keyCode == Declare.Button.NUMBER_02) {
                // 관리PC
                if (!checkNetworkStatus(ConfigValue.strMonitoringPCIPAddress)) {
                    MainActivity.mSound.PlayMent_lobby(R.raw.retryinput);
                }
            } else if (keyCode == Declare.Button.NUMBER_03) {
                // IP 수동입력
                super.setChangeScreen(ID.SCREENS.AdminSet_Test_Network_IP);
            } else if (keyCode == Declare.Button.CANCEL || keyCode == Declare.Button.TACT_CANCEL) {
                super.setChangeScreen(ID.SCREENS.AdminSet_Test);
            }
            UpdateScreen();
        } catch (Exception e) {
            Log.e(TAG, "[Exception] onKeyDown(...) : " + e);
            e.printStackTrace();
        }
        super.onKeyDown(keyCode, event);
    }

    protected void UpdateScreen() {
        try {
//            LOG("[updateScreen] ===== START =====");
            Text_Title.setText(strText_Title);
            Text_Line_01_Item.setText(strText_Line_01_Item);
            Text_Line_02_Item.setText(strText_Line_02_Item);
            Text_Line_03_Item.setText(strText_Line_03_Item);
            Text_Line_04_Item.setText(strText_Line_04_Item);
        } catch (Exception e) {
            Log.e(TAG, "[Exception] updateScreen() : " + e);
            e.printStackTrace();
        }
    }

    public POSITION getPosition(int nID) {
//        LOG("[getPosition] ===== START =====");
        POSITION position = new POSITION();
        position.SetPosition(0, 0, 480, 272);
        try {
            switch (nID) {
                case ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.IMAGES.BACKGROUND:
                    position.SetPosition(0, 0, 480, 272);
                    return position;

                case ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.TITLE:
                    position.SetPosition(0, 24, 480, 40);
                    return position;

                case ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.LINE_01_Item:
                    position.SetPosition(30, 73, 450, 40);
                    return position;

                case ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.LINE_02_Item:
                    position.SetPosition(30, 122, 450, 40);
                    return position;

                case ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.LINE_03_Item:
                    position.SetPosition(30, 171, 450, 40);
                    return position;

                case ID.SCREENS.ADMINSET_TEST_NETWORK.ELEMENTS.TEXTS.LINE_04_Item:
                    position.SetPosition(30, 220, 450, 40);
                    return position;

                default:
                    return position;
            }
        } catch (Exception e) {
            Log.e(TAG, "[Exception] getPosition() : " + e);
            e.printStackTrace();
            return position;
        }
    }

    private boolean checkNetworkStatus(String strTargetIP) {
        try {
            LOG("[checkNetworkStatus] strTargetIP = " + strTargetIP);
            bFUNCBlock = true;
            PingTest mPingTest = new PingTest() {
                @Override
                protected void onPostExecute(String result) {
                    LOG("[checkNetworkStatus.onPostExecute] result = " + result);
                    displayPingResult(result);
                    bFUNCBlock = false;
                }
            };
            strText_Line_04_Item = "잠시만 기다리세요.";
            Text_Line_04_Item.setText(strText_Line_04_Item);
            Text_Line_04_Item.setTextColor(Color.WHITE);
            mPingTest.doPingTest(strTargetIP);
            return true;
        } catch (Exception e) {
            Log.e(TAG, "[Exception] checkNetworkStatus(strTargetIP)");
            e.printStackTrace();
            bFUNCBlock = false;
            return false;
        }
    }

    private void displayPingResult(String strResult) {
        try {
            LOG("[displayPingResult] strResult = " + strResult);
            strText_Line_04_Item = strResult;
            Text_Line_04_Item.setText(strText_Line_04_Item);
            if (strResult.equals("Reachable")) {
                Text_Line_04_Item.setTextColor(Color.GREEN);
            } else {
                Text_Line_04_Item.setTextColor(Color.RED);
            }
        } catch (Exception e) {
            Log.e(TAG, "[Exception] displayPingResult(strResult)");
            e.printStackTrace();
        }
    }


}